INSERT INTO `i18n` (`index`, `group`, `en`, `de`) VALUES
('download_list', 'common', 'Download List', 'Download-Liste'),
('doc_folder', 'common', 'Files from Document Folder', 'Dateien aus Dokumentenordner');

INSERT INTO `register` ( `name`, `call`, `plugin`, `tab`, `params`, `gui`, `top`, `start`, `group`, `icon`, `image`, `level`, `sort`, `frontend`) VALUES
('download_list', 'download_list', 'download_list', '3', '', '1', '', '', 'on', 'list', '1', '1', '280', '');

INSERT INTO `content_types` (`type`, `name`, `icon`, `icon_add`, `new_in_type`, `generate`, `move`) VALUES
('download_list', 'download_list', 'list', 'list-add', 'root,folder,node', 1, 1);

INSERT INTO `html_snippets` SET `key` = 'cms_download_list_item', `description` = 'li od downloadlist', `code` = '<li>\n<a href="&&&&link&&&&" class="linkedtitle"><span class="grey">&&&&icon&&&&</span> &&&&name&&&&</a> (&&&&psize&&&&)\n</li>', `group` = '14';

CREATE TABLE `download_list` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `doc_folder` varchar(128) DEFAULT NULL,
  `pid` bigint(20) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `help` (`parent`, `header`, `body`, `sort`, `tooltip`, `language`) VALUES
('199999999', 'Download-Liste', '<p>Dieses Plugin erstellt eine Seite mit einer Download-Liste. Wählen Sie einen Datei-Ordner für die automatische Erstellung der Liste.</p>', '10', 'download_list', 'de'),
('199999999', 'Download-Liste', '<p>Erstellt eine Seite als Download-Liste aus einem Datei-Ordner<br></p>', '20', 'common.download_list', 'de'),
('199999999', 'Titel', '<p>Der Titel der Liste bildet wie bei allen Seiten zugleich die Überschrift und wird für die Namensgebung der HTML-Datei verwendet. Geben Sie Ihrer Liste einen aussagekräftigen Titel.<br></p>', '770', 'download_list.title', 'de'),
('199999999', 'Kurztitel', '<p>Der Kurztitel wird für den Menü-Eintrag verwendet, er sollte mit dem Titel nachvollziehbar zusammenhängen, muss jedoch entscheidend kürzer sein.<br></p>', '790', 'download_list.short', 'de'),
('199999999', 'Sprache', '<p>Die Sprache ergibt sich aus der Auswahl des Sprachbereiches, aus der heraus die Liste angelegt wurde. Wollen Sie eine andere Sprache verwenden, wählen Sie im linken Baum einen anderen Sprachbereich oder Ordner dieses Bereiches aus und gehen dann auf  "Neuer Eintrag" und "Download-Liste".<br></p>', '810', 'download_list.lang', 'de'),
('199999999', 'Ordner der Liste', '<p>Der Ordner zeigt an, wo die Liste in der Menüstruktur und im Inhaltsverzeichnis aufscheint. Unterste Ebene ist der Ordner <strong>"Home"</strong>. Sämtliche Ordner und Seiten (und somit auch Listen), die sich in HOME befinden, werden in der Hauptnavigation angezeigt.</p><p>Jeder\r\n Ordner kann wiederum weitere Ordner und Seiten beinhalten.</p>', '890', 'download_list.parent', 'de'),
('199999999', 'Vorlagen', '<p>Wählen Sie hier die passende Seiten-Layout-Vorlage.<br></p>', '920', 'download_list.template', 'de'),
('199999999', 'Sortieren', '<p>Die Seiten (und somit auch Listen) erscheinen in den Menüpunkten und in den \r\nInhaltsverzeichnissen in der Reihenfolge ihrer Eingabe. Das heißt: die \r\nzuletzt erstellte Seite ist als erste zu sehen. Um die Reihenfolge \r\nbeliebig zu manipulieren, gibt es das Sortierfeld.</p><p>Sortierungen können bequemer in der Tabellenübersicht vorgenommen werden.<br></p>', '940', 'download_list.sort', 'de'),
('199999999', 'Zeitsteuerung', '<p>Die Veröffentlichung (im Menü) kann auch zeitgesteuert erfolgen. Das Start-Datum setzt die Seite in den Modus "Menü &amp; veröffentlicht", das Ende-Datum setzt sie offline.</p><p>Klappen Sie den Bereich bei Bedarf aus.<br></p>', '1000', 'download_list.cron', 'de'),
('199999999', 'Dokumentenordner', '<p>Wählen Sie hier den Dateienordner aus, aus dessen Dateien die Liste erstellt werden soll.<br></p>', '910', 'download_list.doc_folder', 'de'),
('199999999', 'Beschreibung', '<p>Geben Sie hier je nach Belieben einen Begleittext für die Liste ein.<br></p>', '910', 'download_list.description', 'de');

INSERT INTO `help_folder` ( `name`, `short`, `parent`, `sort`, `language`)
VALUES ('Download-Liste', '', '17', '40', 'de');

UPDATE `help` SET `parent` = (SELECT `id` FROM `help_folder` WHERE `name` = 'Download-Liste') WHERE `parent` = '199999999';
