<?php

class vnstat {

	public function plugin($html) {
		switch ($html['action']) {
			case ("SOMETHINGELSE"): $html = $this->SOMETHINGELSE_admin($html); break;
			default: $html = $this->list($html);
			}
		$html['left'] = get_tab_tree($html, "settings", 'monitor', "");
		return $html;
		}

	private function list($html)	{
		$vnstat_cmd = "/usr/bin/vnstat";
		$interfaces = explode("\n", trim(shell_exec("$vnstat_cmd --dbiflist 1")));
		$iface = $interfaces[0];
		if ($iface) {
			$json = shell_exec($vnstat_cmd." --json h 24".$iface);
			$data = json_decode($json, true);
			//var_dump($data);
			$submen = array(
			[i18n('monitor', true), $html['myurl']."?sid={$html['sid']}&amp;_id=monitor", "inactive", "server"]
			);
		$submen = add_action_to_submenu($submen, 'vnstat', 'active');
		$html['content'] = make_submenu($submen);
		
			$html['content'] .= htmltag('h2', '', $data['interfaces'][0]['name']);
			$html['content'] .= htmltag('p', '', i18n('updated', true).': '.implode('-', $data['interfaces'][0]['updated']['date']).' '.sprintf('%02d', $data['interfaces'][0]['updated']['time']['hour']).':'.sprintf('%02d', $data['interfaces'][0]['updated']['time']['minute']));
			$html['content'] .= htmltag('caption', '', i18n('hours', true));
			$hours = $data['interfaces'][0]['traffic']['hour'];
			$rmax = max(array_column($hours,'rx'));
			$tmax = max(array_column($hours,'tx'));
			$max = $rmax > $tmax ? $rmax : $tmax;
			$table = $this->heading(i18n('hour', true));
			$lastday = false;
			foreach ($hours as $h) {
				$rxV = intval(($h['rx']/$max)*100);
				$txV = intval(($h['tx']/$max)*100);
				$day = implode('-', $h['date']);
				if ($day == $lastday) {$day = '';}
				else {$lastday = $day; $day = htmltag('strong', '', $day);}
				$td = htmltag('td', 'style="width: 12em"', $day.' '.sprintf('%02d', $h['time']['hour']).':00');
				$td .= htmltag('td', 'style="border-left:5px solid #48D1CC;width: 12em"', sizeme($h['rx']));
				$td .= htmltag('td', 'style="border-left:5px solid #90EE90;width: 12em"', sizeme($h['tx']));
				$td .= htmltag('td', '', $this->bar($rxV, $txV));
				$table .= htmltag('tr', '', $td);
				}
			$table = htmltag('table', 'class="table tiny"', $table);
			$html['content'] .= $table;
			$html['content'] .= htmltag('caption', '', i18n('days', true));
			
			$json = shell_exec($vnstat_cmd." --json d 31".$iface);
			$data = json_decode($json, true);
			$days = $data['interfaces'][0]['traffic']['day'];
			$rmax = max(array_column($days,'rx'));
			$tmax = max(array_column($days,'tx'));
			$max = $rmax > $tmax ? $rmax : $tmax;
			$table = $this->heading(i18n('day', true));
			foreach ($days as $d) {
				$rxV = intval(($d['rx']/$max)*100);
				$txV = intval(($d['tx']/$max)*100);
				$day = htmltag('strong', '', implode('-', $d['date']));
				$td = htmltag('td', 'style="width: 12em"', $day);
				$td .= htmltag('td', 'style="border-left:5px solid #48D1CC;width: 12em"', sizeme($d['rx']));
				$td .= htmltag('td', 'style="border-left:5px solid #90EE90;width: 12em"', sizeme($d['tx']));
				$td .= htmltag('td', '', $this->bar($rxV, $txV));
				$table .= htmltag('tr', '', $td);
				}
			$table = htmltag('table', 'class="table tiny"', $table);
			$html['content'] .= $table;
			$html['content'] .= htmltag('caption', '', i18n('months', true));
			
			$json = shell_exec($vnstat_cmd." --json m 12".$iface);
			$data = json_decode($json, true);
			
			$months = $data['interfaces'][0]['traffic']['month'];
			$rmax = max(array_column($months,'rx'));
			$tmax = max(array_column($months,'tx'));
			$max = $rmax > $tmax ? $rmax : $tmax;
			$table = $this->heading(i18n('month', true));
			foreach ($months as $m) {
				$rxV = intval(($m['rx']/$max)*100);
				$txV = intval(($m['tx']/$max)*100);
				$day = htmltag('strong', '', implode('-', $m['date']));
				$td = htmltag('td', 'style="width: 12em"', $day);
				$td .= htmltag('td', 'style="border-left:5px solid #48D1CC;width: 12em"', sizeme($m['rx']));
				$td .= htmltag('td', 'style="border-left:5px solid #90EE90;width: 12em"', sizeme($m['tx']));
				$td .= htmltag('td', '', $this->bar($rxV, $txV));
				$table .= htmltag('tr', '', $td);
				}
			$table = htmltag('table', 'class="table tiny"', $table);
			$html['content'] .= $table;
			}
		else {$html['content'] .= 'vnstat is not available';}
		$html['formtitle'] = i18n('monitor', true).' - vnstat';
		return $html;
		}

	private function bar($rx, $tx) {
		if (!$rx) {$rx = 1;}
		if (!$tx) {$tx = 1;}
		$bar = trim(htmltag('div', "style=\"display:inline-block;background-color:#48D1CC;width:{$rx}px;\"", '&nbsp;'));
		$bar .= htmltag('div', "style=\"display:inline-block;background-color:#90EE90;width:{$tx}px;\"", '&nbsp;');
		return $bar;
    	}

    private function heading($c) {
    	$tr = htmltag('th', '', $c);
    	$tr .= htmltag('th', '', 'receive');
    	$tr .= htmltag('th', '', 'transmit');
    	$tr .= htmltag('th', '', 'rx-tx');
    	return htmltag('tr', '', $tr);
    	}

	}
?>
