/**
 * @Author: consentio
 * @Date:   2018-08-18T16:58:21+02:00
 * @Email:  imb@consentio.at
 * @Filename: jQpwdCheck.js
 * @Last modified by:   consentio
 * @Last modified time: 2024-06-13T15:25:49+02:00
 */



(function($){
	$.fn.pwdCheck = function(opt){
		var defaults = {
			'minchars': 6,
			'uppercase': 1,
			'digits': 1,
			'special' : 0,
			'field': 'ipassword',
			'cmp' : 'iccpassword',
			'icon_ok': 'check',
			'icon_false': 'ban',
			'ok': false
			};
		opt = $.extend(defaults, opt);
		var oForm = $(this);
		var oField = $('#'+opt.field);
		var oCmp = $('#'+opt.cmp);
		// encoded password doesn't apply criteria
		if (oField.val() && oField.val() == oCmp.val()) {opt.ok = true;}
		oField.one('focus', function(){
			//oField.after($('<img>').attr({'src': opt.icon_false, 'id': opt.field+'pass'}).css({'margin-left': '5px'}));
			oField.after($('<i>').attr({'id': opt.field+'pass', 'class': 'fas fa-'+opt.icon_false+' fa-lg red'}).css({'margin-left': '5px'}));
			oField.val('');
			});
		oCmp.one('focus', function(){
			oCmp.after($('<i>').attr({'id': opt.field+'ver', 'class': 'fas fa-'+opt.icon_false+' fa-lg red'}).css({'margin-left': '5px'}));
			oCmp.val('');
			});
		oField.keyup(function(){
			opt.ok = false;
			var pass = check(oField.val());
			if (pass) {
				$('#'+opt.field+'pass').attr({'class': 'fas fa-'+opt.icon_ok+' fa-lg green'});
				oField.removeClass('duty');
				}
			else {$('#'+opt.field+'pass').attr({'class': 'fas fa-'+opt.icon_false+' fa-lg red'});}
			});
		oCmp.keyup(function(){
			if (oField.val() == oCmp.val()) {$('#'+opt.field+'ver').attr({'class': 'fas fa-'+opt.icon_ok+' fa-lg green'});}
			else {$('#'+opt.field+'ver').attr({'class': 'fas fa-'+opt.icon_false+' fa-lg red'});}
			});
		oForm.submit(function(e) {
			var btn = $(this).find("input[type=submit]:focus" );
			if (btn.attr('name') != undefined) {
				var pass = check(oField.val());
				if (opt.ok) {pass = true;} // if password is given and has not been changed
				if (oField.val() != oCmp.val()) {pass = false;}
				if (!pass) {
					$('.dlg').fadeOut('fast');
					oField.addClass('duty');
					oField.focus();
					e.preventDefault();
					}
				}
			});

		function check(a) {
			var ok = true;
			if (a.length < opt.minchars){ok = false;}
			if (a.match(/[1-9]/g) < opt.digits) {ok = false;}
			if (a.match(/[A-Z]/g) < opt.uppercase) {ok = false;}
			if (a.match(/[;,\.\!@\#\$%:\&§\*]/g) < opt.special) {ok = false;}
			return ok;
			}
		}
	})(jQuery);
